"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthUser = exports.DeviceInfo = void 0;
const tslib_1 = require("tslib");
const repository_1 = require("@loopback/repository");
const models_1 = require("../../../models");
class DeviceInfo {
}
exports.DeviceInfo = DeviceInfo;
let AuthUser = class AuthUser extends models_1.User {
    constructor(data) {
        super(data);
    }
};
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'array',
        itemType: 'string',
    }),
    (0, tslib_1.__metadata)("design:type", Array)
], AuthUser.prototype, "permissions", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'string',
        required: true,
    }),
    (0, tslib_1.__metadata)("design:type", String)
], AuthUser.prototype, "role", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'string',
    }),
    (0, tslib_1.__metadata)("design:type", String)
], AuthUser.prototype, "externalAuthToken", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'number',
    }),
    (0, tslib_1.__metadata)("design:type", Number)
], AuthUser.prototype, "age", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'string',
    }),
    (0, tslib_1.__metadata)("design:type", String)
], AuthUser.prototype, "externalRefreshToken", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'number',
    }),
    (0, tslib_1.__metadata)("design:type", Number)
], AuthUser.prototype, "authClientId", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'object',
        description: `This property consists of two optional fields.
    1. userAgent
    2. deviceId `,
    }),
    (0, tslib_1.__metadata)("design:type", DeviceInfo)
], AuthUser.prototype, "deviceInfo", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'string',
    }),
    (0, tslib_1.__metadata)("design:type", String)
], AuthUser.prototype, "pubnubToken", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'object',
    }),
    (0, tslib_1.__metadata)("design:type", Object)
], AuthUser.prototype, "userPreferences", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'string',
    }),
    (0, tslib_1.__metadata)("design:type", String)
], AuthUser.prototype, "tenantId", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'string',
    }),
    (0, tslib_1.__metadata)("design:type", String)
], AuthUser.prototype, "userTenantId", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'date',
    }),
    (0, tslib_1.__metadata)("design:type", Date)
], AuthUser.prototype, "passwordExpiryTime", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'array',
        itemType: 'string',
    }),
    (0, tslib_1.__metadata)("design:type", Array)
], AuthUser.prototype, "allowedResources", void 0);
(0, tslib_1.__decorate)([
    (0, repository_1.property)({
        type: 'number',
        jsonSchema: {
            enum: [
                1 /* ACTIVE */,
                2 /* INACTIVE */,
                3 /* PASSWORD_CHANGE_NEEDED */,
                0 /* REGISTERED */,
                4 /* REJECTED */,
            ],
        },
    }),
    (0, tslib_1.__metadata)("design:type", Number)
], AuthUser.prototype, "status", void 0);
AuthUser = (0, tslib_1.__decorate)([
    (0, repository_1.model)({
        description: `This is the signature for authenticated user which holds permissions and role.`,
    }),
    (0, tslib_1.__metadata)("design:paramtypes", [Object])
], AuthUser);
exports.AuthUser = AuthUser;
//# sourceMappingURL=auth-user.model.js.map